import Taro from '@tarojs/taro';
function AMapWX(a) {
  (this.key = a.key),
    (this.requestConfig = {
      key: a.key,
      s: "rsx",
      platform: "WXJS",
      appname: a.key,
      sdkversion: "1.2.0",
      logversion: "2.0"
    });
}
(AMapWX.prototype.getLocation = function(a, b) {
  Taro.getLocation({
    type: "gcj02",
    success: function(a) {
      var c = a.longitude + "," + a.latitude;
      wx.setStorage({ key: "userLocation", data: c }), b(c);
    },
    fail: function(c) {
      wx.getStorage({
        key: "userLocation",
        success: function(a) {
          a.data && b(a.data);
        }
      }),
        a.fail({ errCode: "0", errMsg: c.errMsg || "" });
    }
  });
}),
  (AMapWX.prototype.getRegeo = function(a) {
    function c(c) {
      var d = b.requestConfig;
      // 疑问
      Taro.request({
        url: "https://restapi.amap.com/v3/geocode/regeo",
        data: {
          key: b.key,
          location: c,
          extensions: "all",
          s: d.s,
          platform: d.platform,
          appname: b.key,
          sdkversion: d.sdkversion,
          logversion: d.logversion
        },
        method: "GET",
        header: { "content-type": "application/json" },
        success: function(b) {
          var d, e, f, g, h, i, j, k, l;
          b.data.status && "1" == b.data.status
            ? ((d = b.data.regeocode),
              (e = d.addressComponent),
              (f = []),
              (g = ""),
              d &&
                d.roads[0] &&
                d.roads[0].name &&
                (g = d.roads[0].name + "附近"),
              (h = c.split(",")[0]),
              (i = c.split(",")[1]),
              d.pois &&
                d.pois[0] &&
                ((g = d.pois[0].name + "附近"),
                (j = d.pois[0].location),
                j &&
                  ((h = parseFloat(j.split(",")[0])),
                  (i = parseFloat(j.split(",")[1])))),
              e.provice && f.push(e.provice),
              e.city && f.push(e.city),
              e.district && f.push(e.district),
              e.streetNumber && e.streetNumber.street && e.streetNumber.number
                ? (f.push(e.streetNumber.street), f.push(e.streetNumber.number))
                : ((k = ""),
                  d && d.roads[0] && d.roads[0].name && (k = d.roads[0].name),
                  f.push(k)),
              (f = f.join("")),
              (l = [
                {
                  iconPath: a.iconPath,
                  width: a.iconWidth,
                  height: a.iconHeight,
                  name: f,
                  desc: g,
                  longitude: h,
                  latitude: i,
                  id: 0,
                  regeocodeData: d
                }
              ]),
              a.success(l))
            : a.fail({ errCode: b.data.infocode, errMsg: b.data.info });
        },
        fail: function(b) {
          a.fail({ errCode: "0", errMsg: b.errMsg || "" });
        }
      });
    }
    var b = this;
    a.location
      ? c(a.location)
      : b.getLocation(a, function(a) {
          c(a);
        });
  });
  (module.exports = AMapWX);
